VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsODBC"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Option Base 1

Private bDebugFlags(1 To 256) As Boolean
Private Const DEBUG_FLAGS_MAX = 256
Private Const DEBUG_FLAGS_MIN = 1

Private nDataSources As Integer
Private nDrivers As Integer

Private sAttributes() As String
Private sConnectStrings() As String
Private sDescriptions() As String
Private sDrivers() As String
Private sDriverDescriptions() As String
Private sDSNs() As String

Private henv As Long
Private benv As Boolean

Private hdbc As Long
Private bdbc As Boolean

Private hstmt As Long
Private bstmt As Boolean

Private sConnectDriver As String
Private sConnectDSN As String
Private sConnectString As String
Private bConnect As Boolean

Private sErrorMessage As String
Private sSQLState As String * 5

Public Sub AllocConnect()

    '   Allocates a connection handle
    
    On Error GoTo Err_AllocConnect

    Dim nSQLResults As Integer
    
    nSQLResults = SQLAllocConnect(henv, hdbc)
    If (SQL_SUCCESS = nSQLResults) Then
        bdbc = True
    Else
        bdbc = False
    End If
    
Exit_AllocConnect:

    Exit Sub
    
Err_AllocConnect:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_AllocConnect
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Sub
    
End Sub
Public Sub AllocEnv()

    '   Allocates an environment handle
    
    On Error GoTo Err_AllocEnv
  
    Dim nSQLResults As Integer
  
    nSQLResults = SQLAllocEnv(henv)
    If (SQL_SUCCESS = nSQLResults) Then
        benv = True
    Else
        benv = False
    End If
  
Exit_AllocEnv:

    Exit Sub

Err_AllocEnv:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_AllocEnv
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Sub
  
End Sub

Public Sub AllocStmt()

    '   Allocates a statement handle

    On Error GoTo Err_AllocStmt

    Dim nSQLResults As Integer
    
    nSQLResults = SQLAllocStmt(hdbc, hstmt)
    If (SQL_SUCCESS = nSQLResults) Then
        bstmt = True
    Else
        bstmt = False
    End If
      
Exit_AllocStmt:

    Exit Sub
    
Err_AllocStmt:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_AllocStmt
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Sub
    
End Sub

Public Function Connect(sDSN As String, sUserid As String, sPassword As String) As Boolean

    '   Connects to the database
    
    On Error GoTo Err_Connect
    
    Dim nSQLResults As Integer
    
    nSQLResults = SQLConnect(hdbc, sDSN & Chr$(0), SQL_NTS, sUserid & Chr$(0), SQL_NTS, sPassword & Chr$(0), SQL_NTS)
    If ((SQL_SUCCESS = nSQLResults) Or (SQL_SUCCESS_WITH_INFO = nSQLResults)) Then
        sConnectDSN = sDSN
        bConnect = True
    Else
        CheckError "SQLConnect: ", nSQLResults
        bConnect = False
    End If

    Connect = bConnect
    
Exit_Connect:

    Exit Function
    
Err_Connect:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_Connect
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Function

End Function
Public Function DriverConnect(sDriver As String, sServer As String, sDatabase As String, sUserid As String, sPassword As String) As Boolean

    '   Connects to the database
    
    On Error GoTo Err_Connect
    
    Dim lConnectStringOutMax As Long
    
    Dim nConnectStringOutReturn As Integer
    Dim nSQLResults As Integer
    
    Dim sConnect As String
    Dim sConnectStringOut As String
    
    '   Build Connect String
    sConnect = "DRIVER={" & sDriver & "}"
    sConnect = sConnect & ";SERVER=" & sServer
    If (0 < InStr(1, sDriver, "Oracle")) Then
        sConnect = sConnect & ";DBQ=" & sServer & ";"
    Else
        sConnect = sConnect & ";SRVR=" & sServer
    End If
    sConnect = sConnect & ";DATABASE=" & sDatabase
    sConnect = sConnect & ";UID=" & sUserid
    sConnect = sConnect & ";PWD=" & sPassword
    sConnectStringOut = String$(2048, Chr$(0))
    lConnectStringOutMax = 2047
    
    '   Connect
    nSQLResults = SQLDriverConnect(hdbc, VB.Forms(1).hWnd, sConnect & Chr$(0), SQL_NTS, sConnectStringOut, lConnectStringOutMax, nConnectStringOutReturn, SQL_DRIVER_COMPLETE)
    If ((SQL_SUCCESS = nSQLResults) Or (SQL_SUCCESS_WITH_INFO = nSQLResults)) Then
        sConnectDriver = sDriver
        sConnectString = Left$(sConnectStringOut, nConnectStringOutReturn)
        bConnect = True
    Else
        CheckError "SQLConnect: ", nSQLResults
        bConnect = False
    End If

    DriverConnect = bConnect
    
Exit_Connect:

    Exit Function
    
Err_Connect:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_Connect
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Function

End Function

Public Sub Delete()

    '   Frees allocated items

    On Error GoTo Err_Delete

    Dim nSQLResults As Integer

    If (0 < nDataSources) Then
        ReDim sDSNs(1)
        sDSNs(1) = ""
        ReDim sDescriptions(1)
        sDescriptions(1) = ""
        nDataSources = 0
    End If
    
    If (bstmt) Then
        nSQLResults = SQLFreeStmt(hstmt, SQL_DROP)
        bstmt = False
    End If
    If (bConnect) Then
        nSQLResults = SQLDisconnect(hdbc)
        If ((SQL_SUCCESS = nSQLResults) Or (SQL_SUCCESS_WITH_INFO = nSQLResults)) Then
            bConnect = False
        Else
            CheckError "SQLDisconnect: ", nSQLResults
        End If
    End If
    If (bdbc) Then
        nSQLResults = SQLFreeConnect(hdbc)
        If ((SQL_SUCCESS = nSQLResults) Or (SQL_SUCCESS_WITH_INFO = nSQLResults)) Then
            bConnect = False
        Else
            CheckError "SQLFreeConnect: ", nSQLResults
        End If
    End If
    If (benv) Then
        nSQLResults = SQLFreeEnv(henv)
        benv = False
    End If
    
Exit_Delete:

    Exit Sub
    
Err_Delete:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_Delete
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Sub
    
End Sub

Public Property Get Description(ByVal vnDescription As Integer) As String

    '   Returns the value of the description property

    On Error GoTo Err_Get_Description
    
    Dim nDummy
    
    If (0 = nDataSources) Then
        nDummy = DataSources()
    End If
    
    If ((1 > vnDescription) Or (nDataSources < vnDescription)) Then
        Description = ""
    Else
        Description = sDescriptions(vnDescription)
    End If

Exit_Get_Description:

    Exit Property
    
Err_Get_Description:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_Get_Description
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Property
    
End Property
Public Property Get ConnectDSN() As String

    '   Returns the value of the ConnectDSN property
    
    On Error GoTo Err_Get_ConnectDSN
    
    Dim nDummy
    
    If (bConnect) Then
        ConnectDSN = sConnectDSN
    Else
        ConnectDSN = ""
    End If

Exit_Get_ConnectDSN:

    Exit Property
    
Err_Get_ConnectDSN:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_Get_ConnectDSN
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Property

End Property
Public Property Get ConnectDriver() As String

    '   Returns the value of the ConnectDriver property
    
    On Error GoTo Err_Get_ConnectDriver
    
    Dim nDummy
    
    If (bConnect) Then
        ConnectDriver = sConnectDriver
    Else
        ConnectDriver = ""
    End If

Exit_Get_ConnectDriver:

    Exit Property
    
Err_Get_ConnectDriver:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_Get_ConnectDriver
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Property

End Property
Public Property Get ConnectString() As String

    '   Returns the value of the ConnectString property
    
    On Error GoTo Err_Get_ConnectString
    
    Dim nDummy
    
    If (bConnect) Then
        ConnectString = sConnectString
    Else
        ConnectString = ""
    End If

Exit_Get_ConnectString:

    Exit Property
    
Err_Get_ConnectString:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_Get_ConnectString
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Property

End Property

Public Property Let DebugFlags(ByVal vnDebugFlag As Integer, ByVal vbDebugFlagValue As Boolean)

    '   Sets the value of the DebugFlags property
    
    If ((DEBUG_FLAGS_MIN > vnDebugFlag) Or (DEBUG_FLAGS_MAX < vnDebugFlag)) Then
        Exit Property
    Else
        Select Case vbDebugFlagValue
            Case True
                bDebugFlags(vnDebugFlag) = True
            Case False
                bDebugFlags(vnDebugFlag) = False
            Case Else
                Exit Property
        End Select
    End If
    
Exit_Let_DebugFlags:

    Exit Property
    
Err_Let_DebugFlags:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_Let_DebugFlags
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Property
    
End Property

Public Property Get DebugFlags(ByVal vnDebugFlag As Integer) As Boolean

    '   Returns the value of the DebugFlags property
    
    If ((DEBUG_FLAGS_MIN > vnDebugFlag) Or (DEBUG_FLAGS_MAX < vnDebugFlag)) Then
        DebugFlags = False
        Exit Property
    Else
        Select Case bDebugFlags(vnDebugFlag)
            Case True
                DebugFlags = True
            Case False
                DebugFlags = False
            Case Else
                Exit Property
        End Select
    End If
    
Exit_Get_DebugFlags:

    Exit Property
    
Err_Set_DebugFlags:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_Get_DebugFlags
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Property
    
End Property
Public Property Get DataSources() As Integer

    '   Saves the DSNs and Descriptions of the ODBC data sources available
    '   Returns the number of ODBC data sources available
    
    On Error GoTo Err_Get_DataSources
    
    Dim nDescriptionLen As Integer
    Dim nDSNLen As Integer
    Dim nIndex As Integer
    Dim nSQLResults As Integer
    
    Dim sDescription As String
    Dim sDSN As String
    
    '   Were we called before?
    If (0 = nDataSources) Then
        '   No -- allocate env
        If (Not benv) Then
            AllocEnv
        End If
        '   Did we get one?
        If (Not benv) Then
            '   No -- give up
            DataSources = nDataSources
            Exit Property
        End If
        '   Get the data sources
        nIndex = 0
        sDescription = String$(256, 0)
        sDSN = String(256, 0)
        nSQLResults = SQLDataSources(henv, SQL_FETCH_FIRST, sDSN, 255, nDSNLen, sDescription, 255, nDescriptionLen)
        Do While (SQL_SUCCESS = nSQLResults)
            nIndex = nIndex + 1
            ReDim Preserve sDescriptions(nIndex) As String
            ReDim Preserve sDSNs(nIndex) As String
            sDSNs(nIndex) = Left$(sDSN, nDSNLen)
            sDescriptions(nIndex) = Left$(sDescription, nDescriptionLen)
            nSQLResults = SQLDataSources(henv, SQL_FETCH_NEXT, sDSN, 255, nDSNLen, sDescription, 255, nDescriptionLen)
        Loop
        nDataSources = nIndex
    End If
    
    '   Return results
    DataSources = nDataSources
    
Exit_Get_DataSources:

    Exit Property

Err_Get_DataSources:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_Get_DataSources
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Property

End Property

Public Property Get Drivers() As Integer

    '   Saves the name and Descriptions of the ODBC drivers available
    '   Returns the number of ODBC drivers available
    
    On Error GoTo Err_Get_Drivers
        
    Dim nAttributes As Integer
    Dim nAttributeLen As Integer
    Dim nDescriptionLen As Integer
    Dim nDriverLen As Integer
    Dim nIndex As Integer
    Dim nSQLResults As Integer
    
    Dim sAttribute As String
    Dim sDescription As String
    Dim sDriver As String
    
    '   Were we called before?
    If (0 = nDrivers) Then
        '   No -- allocate env
        If (Not benv) Then
            AllocEnv
        End If
        '   Did we get one?
        If (Not benv) Then
            '   No -- give up
            Drivers = nDrivers
            Exit Property
        End If
        '   Get the drivers
        nIndex = 0
        sDriver = String$(256, 0)
        sAttribute = String(10240, 0)
        nSQLResults = SQLDrivers(henv, SQL_FETCH_FIRST, sDriver, 255, nDriverLen, sAttribute, 10240, nAttributeLen)
        Do While (SQL_SUCCESS = nSQLResults)
            nIndex = nIndex + 1
            ReDim Preserve sAttributes(nIndex) As String
            ReDim Preserve sDrivers(nIndex) As String
            sAttributes(nIndex) = Left$(sAttribute, nAttributeLen)
            sDrivers(nIndex) = Left$(sDriver, nDriverLen)
            nSQLResults = SQLDrivers(henv, SQL_FETCH_NEXT, sDriver, 255, nDriverLen, sAttribute, 10240, nAttributeLen)
        Loop
        nDrivers = nIndex
    End If
    
    '   Return results
    Drivers = nDrivers
    
Exit_Get_Drivers:

    Exit Property

Err_Get_Drivers:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_Get_Drivers
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Property

End Property


Public Property Get DSN(ByVal vnDSN As Integer) As String

    '
    '   Returns the DSN of an ODBC saved data source
    '
    
    On Error GoTo Err_Get_DSN
    
    Dim nDummy
    
    If (0 = nDataSources) Then
        nDummy = DataSources()
    End If
    
    If ((1 > vnDSN) Or (nDataSources < vnDSN)) Then
        DSN = ""
    Else
        DSN = sDSNs(vnDSN)
    End If

Exit_Get_DSN:

    Exit Property
    
Err_Get_DSN:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_Get_DSN
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Property

End Property

Public Property Get Driver(ByVal vnDriver As Integer) As String

    '
    '   Returns the Driver
    '
    
    On Error GoTo Err_Get_Driver
    
    Dim nDummy
    
    If (0 = nDrivers) Then
        nDummy = Drivers()
    End If
    
    If ((1 > vnDriver) Or (nDrivers < vnDriver)) Then
        Driver = ""
    Else
        Driver = sDrivers(vnDriver)
    End If

Exit_Get_Driver:

    Exit Property
    
Err_Get_Driver:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_Get_Driver
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Property

End Property


Public Property Get Attributes(ByVal vnAttributes As Integer) As String

    '
    '   Returns the Attributes
    '
    
    On Error GoTo Err_Get_Attributes
    
    Dim nDummy
    
    If (0 = nDataSources) Then
        nDummy = DataSources()
    End If
    
    If ((1 > vnAttributes) Or (nDrivers < vnAttributes)) Then
        Attributes = ""
    Else
        Attributes = sAttributes(vnAttributes)
    End If

Exit_Get_Attributes:

    Exit Property
    
Err_Get_Attributes:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_Get_Attributes
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Property

End Property



Public Sub CheckError(ByVal vsMessagePrefix, ByVal vnSQLResults)

    '
    '   Checks error states
    '
    
    On Error GoTo Err_CheckError

    Dim nBuffer As Integer
    Dim nSQLResults As Integer

    Dim lSQLResults As Long

    Static sBuffer As String * 512
    
    '   Initialize the error message with the SQL results code
    sErrorMessage = vsMessagePrefix & "Error(" & Str$(vnSQLResults) & ")"
    sSQLState = Space$(5)
    '   Get the error information
    nSQLResults = SQLError(henv, hdbc, hstmt, sSQLState, lSQLResults, sBuffer, 256, nBuffer)
    If ((SQL_SUCCESS = nSQLResults) Or (SQL_SUCCESS_WITH_INFO = nSQLResults)) Then
        sErrorMessage = sErrorMessage & Chr$(13) & Chr$(10) & Left$(sBuffer, nBuffer)
        '   Get additional information about the error
        While (SQL_SUCCESS_WITH_INFO = nSQLResults)
            nSQLResults = SQLError(henv, hdbc, hstmt, sSQLState, lSQLResults, sBuffer, 256, nBuffer)
            If ((SQL_SUCCESS = nSQLResults) Or (SQL_SUCCESS_WITH_INFO = nSQLResults)) Then
                sErrorMessage = sErrorMessage & Left$(sBuffer, nBuffer)
            End If
        Wend
    End If
    '   Return the formated error
    sErrorMessage = sErrorMessage & Chr$(13) & Chr$(10) & "sSQLState[" & sSQLState & "], SQLResults[" & Str$(lSQLResults) & "]"

Exit_CheckError:

    MsgBox sErrorMessage, vbOKOnly Or vbInformation, "Error"
    
    Exit Sub
    Resume
Err_CheckError:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_CheckError
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Sub
    
End Sub

Public Sub GetFunctions(ByVal vnFunction As Integer, ByRef rbFunctions() As Integer)

    '
    '   Wrapper for the SQLGetFunctions API
    '

    On Error GoTo Err_GetFunctions
    
    Dim nPrepare As Integer
    
    Dim nSQLResults As Integer
    
    nSQLResults = SQLGetFunctions(hdbc, vnFunction, rbFunctions(LBound(rbFunctions)))
    If (SQL_SUCCESS = nSQLResults) Then
    Else
        CheckError "SQLGetFunctions: ", nSQLResults
    End If

Exit_GetFunctions:
    
    Exit Sub
    
Err_GetFunctions:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_GetFunctions
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Sub

End Sub

Public Function GetInfoLong(ByVal vfInfoType As Integer) As Long

    '
    '   Wrapper for the SQLGetInfo API
    '

    On Error GoTo Err_GetInfoLong
    
    Dim nBufferLen As Integer
    Dim nBufferUsed As Integer
    Dim nSQLResults As Integer
    
    Dim lBuffer As Long
    
    If (Not bConnect) Then
        GetInfoLong = 0
        Exit Function
    End If
    
    lBuffer = 0
    nBufferLen = 4
    If (SQL_DRIVER_HSTMT = vfInfoType) Then
        lBuffer = hstmt
    End If
    nSQLResults = SQLGetInfo(hdbc, vfInfoType, lBuffer, ByVal nBufferLen, nBufferUsed)
    If (SQL_SUCCESS = nSQLResults) Then
        GetInfoLong = lBuffer
    Else
        GetInfoLong = 0
        CheckError "SQLGetInfoLong: ", nSQLResults
    End If

Exit_GetInfoLong:

    Exit Function
    
Err_GetInfoLong:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_GetInfoLong
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Function

End Function

Public Function GetInfoShort(ByVal vfInfoType As Integer) As Integer

    '
    '   Wrapper for the SQLGetInfo API
    '

    On Error GoTo Err_GetInfoShort
    
    Dim nBufferLen As Integer
    Dim nBufferUsed As Integer
    Dim nSQLResults As Integer
    
    Dim nBuffer As Integer
    
    If (Not bConnect) Then
        GetInfoShort = 0
        Exit Function
    End If
    
    nBuffer = 0
    nBufferLen = 2
    nSQLResults = SQLGetInfo(hdbc, vfInfoType, nBuffer, ByVal nBufferLen, nBufferUsed)
    If (SQL_SUCCESS = nSQLResults) Then
        GetInfoShort = nBuffer
    Else
        GetInfoShort = 0
        CheckError "SQLGetInfoShort: ", nSQLResults
    End If

Exit_GetInfoShort:

    Exit Function
    
Err_GetInfoShort:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_GetInfoShort
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Function

End Function

Public Function GetInfoStr(ByVal vfInfoType As Integer) As String

    '
    '   Wrapper for the SQLGetInfo API
    '

    On Error GoTo Err_GetInfoStr
    
    Dim nBufferLen As Integer
    Dim nBufferUsed As Integer
    Dim nSQLResults As Integer
    
    Dim sBuffer As String
    
    If (Not bConnect) Then
        GetInfoStr = ""
        Exit Function
    End If
    
    sBuffer = String$(1024, 0)
    nBufferLen = 1023
    nSQLResults = SQLGetInfo(hdbc, vfInfoType, ByVal sBuffer, ByVal nBufferLen, nBufferUsed)
    If (SQL_SUCCESS = nSQLResults) Then
        GetInfoStr = Left$(sBuffer, nBufferUsed)
    Else
        GetInfoStr = ""
        CheckError "SQLGetInforStr: ", nSQLResults
    End If

Exit_GetInfoStr:

    Exit Function
    
Err_GetInfoStr:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_GetInfoStr
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Function

End Function
Private Sub Class_Initialize()

    '
    '   We are being initialized
    '
    
    On Error GoTo Err_Class_Initialize
    
    nDataSources = 0
    
Exit_Class_Initialize:

    Exit Sub
    
Err_Class_Initialize:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_Class_Initialize
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Sub

End Sub


Private Sub Class_Terminate()
    
    '
    '   We are being destroyed
    '
    
    On Error GoTo Err_Class_Terminate
    
    Delete
    
Exit_Class_Terminate:

    Exit Sub
    
Err_Class_Terminate:

    Select Case MsgBox("Error[" & Str$(Err) & "}: " & Error$, vbAbortRetryIgnore Or vbQuestion, "Error")
        Case vbAbort
            Resume Exit_Class_Terminate
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
   
    Exit Sub

End Sub


